summaryrefslogtreecommitdiffstats
path: root/flatpak
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2022-10-23 09:28:19 +0000
committer Eric Hameleers <alien@slackware.com>2022-10-23 09:28:19 +0000
commitdbf58d854ae4953e2cbe0043678c55e8f7ff9ede (patch)
tree137933611372031d018e5a24a9f3f452d9cf607c /flatpak
parenteff58f59e2f49a7d89b38a2328ce9a88403b7965 (diff)
downloadasb-dbf58d854ae4953e2cbe0043678c55e8f7ff9ede.tar.gz
asb-dbf58d854ae4953e2cbe0043678c55e8f7ff9ede.tar.xz
Initial revision
Diffstat (limited to 'flatpak')
-rwxr-xr-xflatpak/build/flatpak.SlackBuild292
-rw-r--r--flatpak/build/slack-desc19
-rw-r--r--flatpak/build/slack-required5
3 files changed, 316 insertions, 0 deletions
diff --git a/flatpak/build/flatpak.SlackBuild b/flatpak/build/flatpak.SlackBuild
new file mode 100755
index 00000000..79e37bde
--- /dev/null
+++ b/flatpak/build/flatpak.SlackBuild
@@ -0,0 +1,292 @@
+#!/bin/sh
+# $Id$
+# Copyright 2022 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: flatpak
+# Descr: linux application sandboxing and distribution framework
+# URL: https://flatpak.org/
+# Build needs:
+# Needs: appstream bubblewrap libostree xdg-desktop-portal-gtk
+# Changelog:
+# 1.14.0-1: 15/oct/2022 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh flatpak.SlackBuild' to build a Slackware package.
+# The package (.t?z) and .txt file as well as build logs are created in /tmp .
+# Install the package using 'installpkg' or 'upgradepkg --install-new'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=flatpak
+VERSION=${VERSION:-1.14.0}
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:-" -j$(nproc) "}
+TAG=${TAG:-alien}
+
+DOCS="COPYING INSTALL NEWS README.md"
+
+# Flatpak system helper (as defined in https://slackbuilds.org/uid_gid.txt):
+FLAT_UID=372
+FLAT_GID=372
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE[0]="$SRCDIR/${PRGNAM}-${VERSION}.tar.xz"
+SRCURL[0]="https://github.com/${PRGNAM}/${PRGNAM}/releases/download/${VERSION}/${PRGNAM}-${VERSION}.tar.xz"
+
+SOURCE[1]="$SRCDIR/flathub.flatpakrepo"
+SRCURL[1]="https://dl.flathub.org/repo/flathub.flatpakrepo"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i586 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+fi
+# Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
+case "$ARCH" in
+ i?86) SLKCFLAGS="-O2 -march=${ARCH} -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ *) SLKCFLAGS=${SLKCFLAGS:-"-O2"}
+ SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+ ;;
+esac
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
+ if ! [ -f ${SOURCE[$i]} ]; then
+ echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
+ if [ -f ${SOURCE[$i]} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL[$i]}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE[$i])"
+ wget --no-check-certificate -nv -T 20 -O "${SOURCE[$i]}" "${SRCURL[$i]}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
+ echo "Fail to download '$(basename ${SOURCE[$i]})'. Aborting the build."
+ mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE[$i]})' not available. Aborting the build."
+ exit 1
+ fi
+ fi
+done
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE[0]}
+cd ${PRGNAM}-${VERSION}
+chown -R root:root .
+chmod -R u+w,go+r-w,a+rX-st .
+
+echo Building ...
+LDFLAGS="$SLKLDFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+CFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --localstatedir=/var \
+ --sysconfdir=/etc \
+ --with-privileged-group=wheel \
+ --with-system-bubblewrap \
+ --with-system-helper-user=flatpak \
+ --disable-static \
+ --program-prefix= \
+ --program-suffix= \
+ --build=$TARGET \
+ 2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
+
+make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+make DESTDIR=$PKG install 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
+
+# Don't ship .la files:
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+# Flatpak would create this otherwise, and by creating it in the package,
+# removepkg can track the content changes:
+mkdir -p $PKG/var/lib/flatpak
+
+# Add flathub definition.
+# The doinst.sh will actually install it as a flatpak remote repository:
+install -D -m 0644 -t $PKG/etc/flatpak/remotes.d $SRCDIR/flathub.flatpakrepo
+
+# We want flatpak enabled out of the box:
+chmod 0755 $PKG/etc/profile.d/flatpak.sh
+
+# Preserve customized profile script:
+mv -i $PKG/etc/profile.d/flatpak.sh{,.new}
+
+# Add this to the doinst.sh:
+mkdir -p $PKG/install
+cat <<EOINS >> $PKG/install/doinst.sh
+# Handle the incoming configuration files:
+config() {
+ for infile in \$1; do
+ NEW="\$infile"
+ OLD="\$(dirname \$NEW)/\$(basename \$NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r \$OLD ]; then
+ mv \$NEW \$OLD
+ elif [ "\$(cat \$OLD | md5sum)" = "\$(cat \$NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm \$NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+ done
+}
+
+preserve_perms() {
+ NEW="\$1"
+ OLD="\$(dirname \$NEW)/\$(basename \$NEW .new)"
+ if [ -e \$OLD ]; then
+ cp -a \$OLD \${NEW}.incoming
+ cat \$NEW > \${NEW}.incoming
+ mv \${NEW}.incoming \$NEW
+ fi
+ config \$NEW
+}
+
+preserve_perms etc/profile.d/flatpak.sh.new
+
+# Only way to create and use the correct uid and gid on the target system,
+# is to use chroot:
+chroot . <<EOR 2>/dev/null
+# Add the '${FLAT_GID}' group if it doesn't exist already:
+/usr/sbin/groupadd -g ${FLAT_GID} flatpak 2> /dev/null
+
+# Add the '${FLAT_UID}' user if it doesn't exist already:
+/usr/sbin/useradd -c "Flatpak system helper" -d /var/lib/flatpak -M \\
+ -s "/bin/false" -g ${FLAT_GID} -u ${FLAT_UID} flatpak 2> /dev/null
+EOR
+
+# Make the flathub repository available to root:
+chroot . \
+ /usr/bin/flatpak remote-add --if-not-exists \
+ flathub /etc/flatpak/remotes.d/flathub.flatpakrepo
+# Inform the user about adding flatpak to their homedirectory:
+echo "NOTE:"
+echo ">> you can add the FlatHub repository for your own user if you do not want to use the 'root' account, by executing the following command:"
+echo ">> flatpak --user remote-add --if-not-exists flathub /etc/flatpak/remotes.d/flathub.flatpakrepo"
+echo ">> In general, add '--user' to any flatpak command to make it apply to your own personal environment."
+echo ""
+EOINS
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/slack-required > $PKG/install/slack-required
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
+
+# Restore the original umask:
+umask ${_UMASK_}
+
diff --git a/flatpak/build/slack-desc b/flatpak/build/slack-desc
new file mode 100644
index 00000000..3295a599
--- /dev/null
+++ b/flatpak/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+flatpak: flatpak (linux application sandboxing and distribution framework)
+flatpak:
+flatpak: Flatpak is a system for building, distributing, and running
+flatpak: sandboxed desktop applications on Linux.
+flatpak: Flatpak can be used by all kinds of desktop applications, and aims
+flatpak: to be as agnostic as possible regarding how applications are built.
+flatpak: While Flatpak only runs on Linux, it can be used by applications
+flatpak: that target other operating systems, as well as those that are
+flatpak: Linux-specific.
+flatpak:
+flatpak: See also: https://flatpak.org/
diff --git a/flatpak/build/slack-required b/flatpak/build/slack-required
new file mode 100644
index 00000000..004ce35a
--- /dev/null
+++ b/flatpak/build/slack-required
@@ -0,0 +1,5 @@
+appstream
+bubblewrap
+libostree
+xdg-desktop-portal-gtk
+